/*  TAB_ALUNOS
*
*   Este programa l dados de alunos e notas para uma tabela no formato abaixo:
*
*   Nome Aluno	  # Matrcula   Nota 1   Nota 2   Nota 3   Media
*  +------------+-------------+--------+--------+--------+--------+
*  |            |             |        |        |        |        |
*  +------------+-------------+--------+--------+--------+--------+
*  |            |             |        |        |        |        |
*  +------------+-------------+--------+--------+--------+--------+
*  |            |             |        |        |        |        |
*  +------------+-------------+--------+--------+--------+--------+
*
*   Nome Aluno:  matriz string com 20 caracteres
*   #Matricula:  matriz int
*   Nota 1, Nota 2, Nota 3 e Media:  matriz float
*
*   A tabela dever ter um nmero de linhas configurvel por um DEFINE.
*
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define LIN 2 //nmero de linhas da tabela

void le_dados(char nome[][20], int matr[], float nota[][4], int size);
void mostra(char nome[][20], int matr[], float nota[][4], int size);

int main() {
	char nome[LIN][20]={0};
	int matr[LIN]={0}, choice;
	float nota[LIN][4]={0};

	while (1) {
		printf("\n\nControle de Notas de Alunos\n\n");
		printf("(1)  Entrar dados\n");
		printf("(2)  Mostrar dados\n");
		printf("(0)  Sair do programa\n\n");
		printf("  Escolha sua opcao:  ");
		flushall();
		scanf("%d", &choice);
		switch (choice) {
			case 1:
				le_dados(nome, matr, nota, LIN);
				break;
			case 2:
				mostra(nome, matr, nota, LIN);
				break;
			case 0:
				return 0;
				break;
			default:
				printf("\nEntrada invalida.\n");
				break;
		}
	}
}



/*  L DADOS PARA A TABELA
*
*   Esta funo l cada coluna da tabela, exceto a ltima (mdia), que ser calculada a partir dos valores de Nota 1, Nota 2 e Nota 3
*   (mdia aritmtica).
*   Os parmetros a passar so os ponteiros para as trs matrizes envolvidas e o tamanho em linhas para cada matriz.
*/
void le_dados(char nome[][20], int matr[], float nota[][4], int size) {
	int i, j;
	float media;
	char *p;

	printf("\n\nEntrada de Dados\n\n");
	for (i=0; i<size; i++) {
		printf("\nNome aluno %d:  ", i+1);
		flushall();
		fgets(nome[i], 20, stdin); //limita  entrada a 49 letras, pois ltima posio (coluna) tem de ser reservado para \0
		flushall(); //limpa resqucios deixados no buffer
		/* preciso remover o caractere newline do string digitado.
		strchr busca o char '\n' (newline) no string digitado.  O ponteiro p  igualado ao retorno desta funo dentro do if.
		Se o ponteiro no for NULL (isto , o newline foi encontrado), ento o contedo da memria apontado por p  substitudo por \0.
		Ou seja, o newline  substitudo por \o no string nome[i].*/
		if ((p=strchr(nome[i], '\n')) != NULL)
			*p = '\0';

		printf("Numero Matricula aluno %d:  ", i+1);
		scanf("%d", &matr[i]);
		media=0;
		for (j=0; j<3; j++) {
			printf("Nota %d (aluno %d):  ", j+1, i+1);
			scanf("%f", &nota[i][j]);
			media=media+nota[i][j];
		}
		nota[i][3]=media/3; //calcula e armazena mdia na ltima coluna da tabela
	}
}

/*  MOSTRA A TABELA COMPLETA NA TELA
*
*   Os parmetros a passar so os ponteiros para as trs matrizes envolvidas e o tamanho em linhas para cada matriz.
*/
void mostra(char nome[][20], int matr[], float nota[][4], int size) {
	int i, j;

	printf("\n\n\t\t\t\tTabela de Notas\n\n");
	printf("Nome Aluno          #Matricula  Nota 1    Nota 2    Nota 3     Media\n");
	printf("--------------------------------------------------------------------");
	for (i=0; i<size; i++) {
		printf("\n%-19s   %6d", nome[i], matr[i]);
		for (j=0; j<4; j++) {
			printf("      %4.1f", nota[i][j]);
		}
	}
}

